/*
 * EventOut.h
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#ifndef _EVENTOUT_H
#define _EVENTOUT_H

#ifndef _ELEMENT_H
#include "Element.h"
#endif
#ifndef _STRING_H
#include "String.h"
#endif

class ExposedField;

class EventOut : public Element {
public:
		    EventOut(int type, const String &name,
			     ExposedField *exposedField = NULL);
    virtual	   ~EventOut();
    virtual int	    getElementType() const { return EL_EVENT_OUT; }
    virtual void    write(FILE *f, int indent) const;

    int		    getType() const { return _type; }
    const String   &getName() const { return _name; }
    ExposedField   *getExposedField() const { return _exposedField; }

private:
    int		    _type;
    String	    _name;
    ExposedField   *_exposedField;
};

#endif // _EVENTOUT_H
