/*
 * MFColor.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h> 
#include <assert.h>
#include "stdafx.h"

#include "MFColor.h"
#include "SFColor.h"

MFColor::MFColor() : MFFloat()
{
}

MFColor::MFColor(float *values, int len) : MFFloat(values, len)
{
}

bool
MFColor::equals(const FieldValue *value) const
{
    return value->getType() == MFCOLOR && MFFloat::equals((const MFFloat *) value);
}

FieldValue *
MFColor::getSFValue(int index) const
{
    return new SFColor(_value + index * 3);
} 

void
MFColor::setSFValue(int index, FieldValue *value)
{
    if (value->getType() != SFCOLOR) {
	assert(0);
	return;
    }

    const float	*values = ((SFColor *) value)->getValue();

    _value[index*3] = values[0];
    _value[index*3+1] = values[1];
    _value[index*3+2] = values[2];
}

void 
MFColor::clamp(const FieldValue *min, const FieldValue *max)
{
    for (int i = 0; i < _len; i++) {
	if (_value[i] < 0.0f) _value[i] = 0.0f;
	if (_value[i] > 1.0f) _value[i] = 1.0f;
    }
}
