/*
 * MFVec2f.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h> 
#include <assert.h>
#include "stdafx.h"

#include "MFVec2f.h"
#include "SFVec2f.h"

MFVec2f::MFVec2f() : MFFloat()
{
}

MFVec2f::MFVec2f(float *values, int len) : MFFloat(values, len)
{
}

bool
MFVec2f::equals(const FieldValue *value) const
{
    return value->getType() == MFVEC2F && MFFloat::equals((const MFFloat *) value);
}

FieldValue *
MFVec2f::getSFValue(int index) const
{
    return new SFVec2f(_value + index * 2);
} 

void
MFVec2f::setSFValue(int index, FieldValue *value)
{
    if (value->getType() != SFVEC2F) {
	assert(0);
	return;
    }

    const float	*values = ((SFVec2f *) value)->getValue();

    _value[index*2] = values[0];
    _value[index*2+1] = values[1];
}
