/*
 * NodeElevationGrid.h
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#ifndef _NODE_ELEVATIONGRID_H
#define _NODE_ELEVATIONGRID_H

#ifndef _NODE_H
#include "Node.h"
#endif
#ifndef _PROTO_H
#include "Proto.h"
#endif

class Mesh;

class NodeElevationGrid : public Node {
public:
		    NodeElevationGrid(Scene *scene, Proto *proto);

protected:
    virtual	   ~NodeElevationGrid();

public:
    virtual int	    getType() const { return NODE_ELEVATION_GRID; }
    virtual Node   *copy() const { return new NodeElevationGrid(*this); }
    virtual int	    getNodeClass() const { return NODE_GEOMETRY; }

    virtual void	setField(int index, FieldValue *value);

    virtual Vec3f   getHandle(int handle, int *constraint, int *field);
    virtual void    setHandle(int handle, const Vec3f &v);

    virtual void    draw();
    virtual void    drawHandles();

protected:
    void	    createMesh();
   
protected:
    Mesh	   *_mesh;
    bool	    _meshDirty;
};

class ProtoElevationGrid : public Proto {
public:
		    ProtoElevationGrid(Scene *scene);
    virtual Node   *create(Scene *scene)
		    { return new NodeElevationGrid(scene, this); }
};

#endif // _NODE_ELEVATIONGRID_H
