/*
 * NodePointLight.h
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#ifndef _NODE_POINTLIGHT_H
#define _NODE_POINTLIGHT_H

#ifndef _NODE_H
#include "Node.h"
#endif
#ifndef _PROTO_H
#include "Proto.h"
#endif

class NodePointLight : public Node {
public:
		    NodePointLight(Scene *scene, Proto *proto);

    virtual int	    getType() const { return NODE_POINT_LIGHT; }
    virtual Node   *copy() const { return new NodePointLight(*this); }

    virtual void    preDraw();
    virtual void    drawHandles();

    virtual Vec3f   getHandle(int handle, int *constraint, int *field);
    virtual void    setHandle(int handle, const Vec3f &v);
protected:
    GLenum	    _light;
};

class ProtoPointLight : public Proto {
public:
		    ProtoPointLight(Scene *scene);
    virtual Node   *create(Scene *scene)
		    { return new NodePointLight(scene, this); }
};

#endif // _NODE_POINTLIGHT_H
