/*
 * NodeScript.h
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#ifndef _NODE_SCRIPT_H
#define _NODE_SCRIPT_H

#ifndef _NODE_H
#include "Node.h"
#endif
#ifndef _PROTO_H
#include "Proto.h"
#endif

class NodeScript : public Node {
public:
		    NodeScript(Scene *scene);

protected:
    virtual	   ~NodeScript();

public:
    virtual int	    getType() const { return NODE_SCRIPT; }
    virtual Node   *copy() const { return new NodeScript(*this); }
    virtual void    write(FILE *f, int indent);

    virtual void    update();
};

class ProtoScript : public Proto {
public:
		    ProtoScript(Scene *scene);
    virtual Node   *create(Scene *scene)
		    { return new NodeScript(scene); }
};

#endif // _NODE_SCRIPT_H
