/*
 * NodeSound.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "NodeSound.h"
#include "Proto.h"
#include "FieldValue.h"
#include "SFVec3f.h"
#include "SFFloat.h"
#include "SFNode.h"
#include "SFBool.h"


ProtoSound::ProtoSound(Scene *scene)
  : Proto(scene, "Sound")
{
    addExposedField(SFVEC3F, "direction", new SFVec3f(0.0f, 0.0f, 1.0f));
    addExposedField(SFFLOAT, "intensity", new SFFloat(1.0f),
    		    new SFFloat(0.0f), new SFFloat(1.0f));
    addExposedField(SFVEC3F, "location", new SFVec3f(0.0f, 0.0f, 0.0f));
    addExposedField(SFFLOAT, "maxBack", new SFFloat(10.0f),
    		    new SFFloat(0.0f));
    addExposedField(SFFLOAT, "maxFront", new SFFloat(10.0f), new SFFloat(0.0f));
    addExposedField(SFFLOAT, "minBack", new SFFloat(1.0f), new SFFloat(0.0f));
    addExposedField(SFFLOAT, "minFront", new SFFloat(1.0f), new SFFloat(0.0f));
    addExposedField(SFFLOAT, "priority", new SFFloat(0.0f),
    		    new SFFloat(0.0f), new SFFloat(1.0f));
    addExposedField(SFNODE, "source", new SFNode(NULL), NODE_AUDIO_CLIP);
    addField(SFBOOL, "spatialize", new SFBool(true));
}

NodeSound::NodeSound(Scene *scene, Proto *def)
  : Node(scene, def)
{
}

