/*
 * SFFloat.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "SFFloat.h"

SFFloat::SFFloat(float value)
{
    _value = value;
}

void SFFloat::write(FILE *f, int /* indent */) const
{
    fprintf(f, "%g\n", _value);
}

bool
SFFloat::equals(const FieldValue *value) const
{
    return value->getType() == SFFLOAT
	    && ((SFFloat *) value)->getValue() == _value;
}

void
SFFloat::clamp(const FieldValue *min, const FieldValue *max)
{
    if (min) {
	float	fmin = ((SFFloat *) min)->getValue();
	if (_value < fmin) _value = fmin;
    }

    if (max) {
	float	fmax = ((SFFloat *) max)->getValue();
	if (_value > fmax) _value = fmax;
    }
}
