/*
 * main.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#ifdef WIN32
#include <windows.h>
#endif

#include "stdafx.h"
#include "swt.h"

#include "DuneApp.h"
#include "MainWindow.h"

#ifdef WIN32
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE prevInstance,
		    LPSTR lpCmdLine, int nCmdShow)
{
    swInitialize(hInstance);
    TheApp = new DuneApp();
    if (lpCmdLine[0]) {
	if (!TheApp->OpenFile(lpCmdLine)) {
	    return 1;
	}
    } else {
	TheApp->OnFileNew();
    }
    swMainLoop();
    delete TheApp;
    return 0;
}

#else
int main(int argc, char *argv[])
{
    swInitialize(&argc, argv);
    TheApp = new DuneApp();
    switch (argc) {
      case 1:
	TheApp->OnFileNew();
	break;
      case 2:
	if (!TheApp->OpenFile(argv[1])) {
	    perror(argv[1]);
	    return 1;
	}
	break;
      default:
	fprintf(stderr, "usage:  %s [file.wrl]\n", argv[0]);
	return 1;
    }
    swMainLoop();
    delete TheApp;
    return 0;
}
#endif
