/*
 * stdafx.h
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#ifndef _STDAFX_H
#define _STDAFX_H

#ifdef WIN32

#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#include <windows.h>
#include <sys/timeb.h>

#define strcasecmp _stricmp
#define snprintf _snprintf

#include <stdio.h>
#include <assert.h>
#include <float.h>
#include <limits.h>

#include <GL/gl.h>
#include <GL/glu.h>

#endif // WIN32

#ifndef MAX
#define MAX(a, b)   ((a) > (b) ? (a) : (b))
#endif

#ifndef MIN
#define MIN(a, b)   ((a) < (b) ? (a) : (b))
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef CLAMP
#define CLAMP(v, min, max)  MIN(MAX(v, min), max)
#endif

#ifndef PI
#define PI 3.141592653589f
#endif

#define EPSILON		    1E-6
#define EQUALF(a, b)	    (fabs((a) - (b)) < EPSILON)

#ifndef RAD2DEG
#define RAD2DEG(a) ((a) * (180.0f / PI))
#define DEG2RAD(a) ((a) * (PI / 180.0f))
#endif

#endif // _STDAFX_H
